## postgresql-pljava 1.3.0

=== Makefile ===
#-------------------------------------------------------------------------
# Copyright (c) 2004, 2005, 2006 TADA AB - Taby Sweden
# Distributed under the terms shown in the file COPYRIGHT
# found in the root folder of this project or at
# http://eng.tada.se/osprojects/COPYRIGHT.html
#
# @author Thomas Hallgren
#
# Top level Makefile for PLJava
#
# To compile a PLJava for PostgreSQL 8.x the makefile system will utilize
# the PostgreSQL pgxs system. The only prerequisite for such a compile is
# that a PostgreSQL 8.x is installed on the system and that the PATH is set
# so that the binaries of this installed can be executed.
#
# The following options are recognized (aside from normal options like
# CFLAGS etc.)
#
#   PGSQLDIR=<pgsql root>  For old style (not pgxs based) compilation
#   USE_GCJ=1              Builds a shared object file containing both
#                          C and Java code. Requires GCJ 3.4 or later.
#
#-------------------------------------------------------------------------

# Can't use $(shell pwd) directly since /bin/pwd doesn't handle mounted
# volumes very well on some systems. The /mnt/hgfs that enables host shares
# in a vmware client is one example of this.
#
export PROJDIR := $(shell $(SHELL) -c pwd)

PG_CONFIG = pg_config
export PGXS := $(shell $(PG_CONFIG) --pgxs)
export PGSQLSRC := $(dir $(PGXS))..
export top_builddir := $(PGSQLSRC)/..

export TARGETDIR		:= $(PROJDIR)/build
export OBJDIR			:= $(TARGETDIR)/objs
export JNIDIR			:= $(TARGETDIR)/jni
export CLASSDIR			:= $(TARGETDIR)/classes
export PLJAVA_MAJOR_VER	:= 1
export PLJAVA_MINOR_VER	:= 3
export PLJAVA_PATCH_VER	:= 0
export PLJAVA_VERSION	:= $(PLJAVA_MAJOR_VER).$(PLJAVA_MINOR_VER).$(PLJAVA_PATCH_VER)
export TAR				:= /bin/tar

OS := $(shell uname -s)
MACHINE := $(shell uname -m)

.PHONY: all clean docs javadoc source_tarball maven_bundle install uninstall depend release \
	c_all c_install c_uninstall c_depend \
	pljava_all pljava_javadoc \
	deploy_all deploy_javadoc \
	examples_all examples_javadoc \
	test_all test_javadoc

all: pljava_all deploy_all c_all examples_all

install: c_install

uninstall: c_uninstall

depend: c_depend

docs:
	@-mkdir -p $(TARGETDIR)
	@find docs \( \
		   -name CVS \
		-o -name .cvsignore \
		\) -prune -o \( -type f -exec cp --parents {} $(TARGETDIR) \; \)
	@cp COPYRIGHT $(TARGETDIR)/docs/COPYRIGHT.txt

javadoc: pljava_javadoc deploy_javadoc examples_javadoc

clean:
	@-rm -rf $(TARGETDIR)

pljava_all pljava_javadoc: pljava_%:
	@-mkdir -p $(CLASSDIR)/pljava
	@$(MAKE) -r -C $(CLASSDIR)/pljava -f $(PROJDIR)/src/java/pljava/Makefile \
	MODULEROOT=$(PROJDIR)/src/java $*

deploy_all deploy_javadoc: deploy_%:
	@-mkdir -p $(CLASSDIR)/deploy
	@$(MAKE) -r -C $(CLASSDIR)/deploy -f $(PROJDIR)/src/java/deploy/Makefile \
	MODULEROOT=$(PROJDIR)/src/java $*

examples_all: examples_%: pljava_all
	@-mkdir -p $(CLASSDIR)/examples
	@$(MAKE) -r -C $(CLASSDIR)/examples -f $(PROJDIR)/src/java/examples/Makefile \
	MODULEROOT=$(PROJDIR)/src/java $*

test_all: test_%:
	@-mkdir -p $(CLASSDIR)/test
	@$(MAKE) -r -C $(CLASSDIR)/test -f $(PROJDIR)/src/java/test/Makefile \
	MODULEROOT=$(PROJDIR)/src/java $*

c_all c_install c_uninstall c_depend: c_%:
	@-mkdir -p $(OBJDIR)
	@$(MAKE) -r -C $(OBJDIR) -f $(PROJDIR)/src/C/pljava/Makefile \
	MODULEROOT=$(PROJDIR)/src/C build_$*

source_tarball:
	@-mkdir -p $(TARGETDIR)/distrib
	@$(MAKE) -r -C $(TARGETDIR) -f $(PROJDIR)/packaging/Makefile $@

release: all docs javadoc
	@-mkdir -p $(TARGETDIR)/distrib
	@$(MAKE) -r -C $(TARGETDIR) -f $(PROJDIR)/packaging/Makefile $@

maven_bundle: pljava_all
	@-mkdir -p $(TARGETDIR)/distrib
	@$(MAKE) -r -C $(TARGETDIR) -f $(PROJDIR)/packaging/Makefile $@

=== packaging/Makefile ===
#-------------------------------------------------------------------------
# Copyright (c) 2003, 2004 TADA AB - Taby Sweden
# Distributed under the terms shown in the file COPYRIGHT.
#
# @author Thomas Hallgren
#-------------------------------------------------------------------------
include $(PGXS)
 
SS_VERSION := $(subst ., ,$(subst devel,.devel,$(subst beta,.beta,$(VERSION))))
PGSQL_MAJOR_VER = $(word 1,$(SS_VERSION))
PGSQL_MINOR_VER = $(word 2,$(SS_VERSION))
DISTRIB := distrib

ifdef USE_GCJ
	GCJEXTRA=-gcj-
else
	GCJEXTRA=-
endif

RELNAME := pljava-$(host_tuple)$(GCJEXTRA)pg$(PGSQL_MAJOR_VER).$(PGSQL_MINOR_VER)-$(PLJAVA_VERSION)
SRCNAME := pljava-src-$(PLJAVA_VERSION)
PKGNAME := pljava-$(PLJAVA_VERSION)

release:
	@-mkdir -p $(RELNAME)
	@-rm -f $(RELNAME)/*
	@find .	\(				\
		   -name '*.jar'	\
		-o -name '*.so'		\
		-o -name '*.dll'	\
		\) -a -not -path ./$(RELNAME)'/*' -exec cp {} $(RELNAME) \;
	@cp ../src/sql/*.sql $(RELNAME)
	@$(TAR) cf $(RELNAME)/docs.tar docs
	(cd $(RELNAME); $(TAR) zcf ../distrib/$(RELNAME).tar.gz .)

source_tarball:
	@-mkdir -p distrib
	@-mkdir -p $(PKGNAME)
	@-rm -rf $(PKGNAME)/*
	@(cd ..; find . \( \
		   -name CVS \
		-o -name bin \
		-o -name build \
		-o -name .cvsignore \
		\) -prune -o \( -type f -exec cp --parent {} build/$(PKGNAME) \; \) )
	@$(TAR) zcf $(DISTRIB)/$(SRCNAME).tar.gz $(PKGNAME)

JAR				:= jar

PUBLIC_ROOT		:= classes/pljava
PUBLIC_CLASSES	:= $(wildcard $(PUBLIC_ROOT)/org/postgresql/pljava/*.*)
PUBLIC_REL_CLASSES = $(foreach var,$(PUBLIC_CLASSES),$(subst $(PUBLIC_ROOT)/,,$(var)))

PUBLIC_SRC_ROOT	:= ../src/java/pljava
PUBLIC_SRCS		:= $(wildcard $(PUBLIC_SRC_ROOT)/org/postgresql/pljava/*.*)
PUBLIC_REL_SRCS = $(foreach var,$(PUBLIC_SRCS),$(subst $(PUBLIC_SRC_ROOT)/,,$(var)))

PUBLIC_NAME		:= pljava-public-$(PLJAVA_VERSION)
PUBLIC_BUNDLE	:= distrib/$(PUBLIC_NAME)-bundle.jar
JIRA_DESC		:= distrib/jira-desc.txt
BUNDLEDIR		:= maven_bundle
PUBLIC_JARFILE	:= $(PUBLIC_NAME).jar
PUBLIC_SRC_JARFILE	:= $(PUBLIC_NAME)-src.jar

maven_bundle: $(PUBLIC_BUNDLE) $(JIRA_DESC)

$(PUBLIC_BUNDLE): $(BUNDLEDIR)/LICENSE.txt $(BUNDLEDIR)/project.xml $(BUNDLEDIR)/$(PUBLIC_JARFILE) $(BUNDLEDIR)/$(PUBLIC_SRC_JARFILE)
	@(cd $(BUNDLEDIR); $(JAR) cf ../$@ *)

$(BUNDLEDIR)/LICENSE.txt: $(PROJDIR)/COPYRIGHT
	@-mkdir -p $(BUNDLEDIR)
	@cp $< $(BUNDLEDIR)/LICENSE.txt

$(BUNDLEDIR)/project.xml: $(PROJDIR)/packaging/project.xml
	@-mkdir -p $(BUNDLEDIR)
	@sed -e 's/@PLJAVA_VERSION@/'$(PLJAVA_VERSION)'/' $< > $@

$(BUNDLEDIR)/$(PUBLIC_JARFILE): $(PUBLIC_CLASSES)
	@-mkdir -p $(BUNDLEDIR)
	@(cd $(PUBLIC_ROOT); $(JAR) cf ../../$@ $(PUBLIC_REL_CLASSES))

$(BUNDLEDIR)/$(PUBLIC_SRC_JARFILE): $(PUBLIC_SRCS)
	@-mkdir -p $(BUNDLEDIR)
	@(cd $(PUBLIC_SRC_ROOT); $(JAR) cf ../../../build/$@ $(PUBLIC_REL_SRCS)) 

$(JIRA_DESC): $(PROJDIR)/packaging/jira-desc.txt
	@sed -e 's/@PLJAVA_VERSION@/'$(PLJAVA_VERSION)'/' $< > $@

=== src/C/pljava/Makefile ===
#-------------------------------------------------------------------------
# Copyright (c) 2004, 2005, 2006 TADA AB - Taby Sweden
# Distributed under the terms shown in the file COPYRIGHT
# found in the root folder of this project or at
# http://eng.tada.se/osprojects/COPYRIGHT.html
#
# @author Thomas Hallgren
#-------------------------------------------------------------------------
MODULE_big	:= pljava
SRCDIR	:= $(MODULEROOT)/$(MODULE_big)
INCLDIR	:= -I$(MODULEROOT)/include -I$(JNIDIR)

mkobjs	= $(subst $(SRCDIR)/,,$(1:%.c=%.o))
SRCS	= $(shell find $(SRCDIR) -name CVS -prune -o -type f -name \*.c -print)
OBJS	= $(call mkobjs,$(SRCS))

DLLTOOL_DEFFLAGS := --add-stdcall-alias

.PHONY: checkjavahome build pljava-plugin

$(OBJS): %.o : $(SRCDIR)/%.c
	@-mkdir -p $(@D)
	$(CC) -c $(CFLAGS) $(CPPFLAGS) $< -o $@

# Must include PGXS at this point since it defines PORTNAME and VERSION
#
include $(PGXS)

SS_VERSION := $(subst ., ,$(subst devel,.99,$(subst beta,.99,$(VERSION))))
PGSQL_MAJOR_VER	= $(word 1,$(SS_VERSION))
PGSQL_MINOR_VER	= $(word 2,$(SS_VERSION))
PGSQL_PATCH_VER	= $(word 3,$(SS_VERSION))

PLJAVA_CPPFLAGS = \
	-DPKGLIBDIR=\"$(pkglibdir)\" $(INCLDIR) \
	-DPGSQL_MAJOR_VER=$(PGSQL_MAJOR_VER) \
	-DPGSQL_MINOR_VER=$(PGSQL_MINOR_VER) \
	-DPGSQL_PATCH_VER=$(PGSQL_PATCH_VER)

ifeq ($(PORTNAME), win32)
	DLL_BUILD := 1
else
ifeq ($(PORTNAME), darwin)
	#
	# override with JAVAVM_FWX_ROOT=/... on command line
	# if something else is needed
	#
	JAVAVM_FWX_ROOT := /System/Library/Frameworks
	PLJAVA_CPPFLAGS += -I$(JAVAVM_FWX_ROOT)/JavaVM.framework/Headers/
else
ifeq ($(PORTNAME), ibmos2)
	DLL_BUILD := 1
else
	JRE_INCL := $(PORTNAME)
	ifeq ($(host_cpu), i686)
		JRE_CPU := i386
	else
	ifeq ($(host_cpu), x86_64)
		JRE_CPU := amd64
	else
		JRE_CPU := $(host_cpu)
	endif
	endif

endif
endif
endif

ifdef USE_GCJ
	PLJAVA_CPPFLAGS += -DGCJ
	SHLIB_LINK = -lgcj
	ifdef DLL_BUILD
		SHLIB_LINK += -lws2_32
	endif
	OBJS += pljava_jar.o
else
	pljava-jar = pljava.jar
	ifeq ($(PORTNAME), darwin)
		SHLIB_LINK += -L. -framework JavaVM
	else
		ifdef JAVA_HOME
			ifeq ($(PORTNAME), win32)
				JDK_HOME := $(subst \,/,$(JAVA_HOME))
			else
				JDK_HOME := $(JAVA_HOME)
			endif
		else
			ifeq ($(PORTNAME), ibmos2)
				JAVA_HOME_TEST_RESULT := $(echo "You must set JAVA_HOME")
			else
				JAVA_HOME_TEST_RESULT := $(error You must set JAVA_HOME)
			endif
		endif
		ifdef DLL_BUILD
			ifeq ($(PORTNAME),ibmos2)
				JRE_INCL := os2
			else
				JRE_INCL := win32
			endif
			JVM_LIB  := $(JDK_HOME)/jre/bin/client
		else
			JRE_LIB := $(JDK_HOME)/jre/lib/$(JRE_CPU)
			JVM_LIB := $(firstword $(shell /bin/ls -d \
				$(JRE_LIB)/client \
				$(JRE_LIB)/server \
				$(JRE_LIB)/jrockit \
				2> /dev/null))
		endif

		PLJAVA_CPPFLAGS += -I"$(JDK_HOME)/include" -I"$(JDK_HOME)/include/$(JRE_INCL)"
		SHLIB_LINK += -L. -L"$(JVM_LIB)" -ljvm
	endif
endif

ifeq ($(JRE_INCL), win32)
#
# Mingw is a bit special in that we use a "normal" windows
# port of the Java Runtime Environment (unless we use gcj
# of course). The headers etc. for the JRE is windows style
# and contains __int64. GNU compiler doesn't know __int64,
# instead it uses long long.
#
ifndef USE_GCJ

PLJAVA_CPPFLAGS += -D__int64='long long'

# Don't use higher standard then c89 since this rules out older compilers. We
# must use 'long long' however, since JNI defines it.
#
PLJAVA_CFLAGS += -Wno-long-long

endif
endif

override CPPFLAGS += $(PLJAVA_CPPFLAGS)
override CFLAGS += $(PLJAVA_CFLAGS)

# shlib naming convention for plugins (no 'lib')
#
plugin = $(NAME)$(DLSUFFIX)
soname = $(plugin)
shlib  = $(plugin)

ifndef USE_GCJ
checkjavahome:
	$(JAVA_HOME_TEST_RESULT)
endif

ifneq ($(PORTNAME), win32)
ifneq ($(PORTNAME), aix)

# Normal case
#
$(plugin): $(OBJS)
	$(LINK.shared) $(LDFLAGS_SL) $(OBJS) $(SHLIB_LINK) -o $(plugin)

else # PORTNAME == aix

# AIX case
#
$(plugin): lib$(NAME).a
	$(MKLDEXPORT) lib$(NAME).a > $(NAME)$(EXPSUFF)
	$(COMPILER) $(LDFLAGS_NO_L) $(LDFLAGS_SL) -o $(plugin) $< -Wl,-bE:$(NAME)$(EXPSUFF) $(SHLIB_LINK)

endif # PORTNAME == aix

else # PORTNAME == win32

# win32 case
#
$(plugin): $(OBJS)
ifndef USE_GCJ
	$(DLLTOOL) --input-def $(SRCDIR)/jvm.def --kill-at --dllname jvm.dll --output-lib libjvm.dll.a
endif
	$(DLLTOOL) --export-all $(DLLTOOL_DEFFLAGS) --output-def $(NAME).def $(OBJS)
	$(DLLWRAP) $(LDFLAGS_SL) -o $(plugin) --dllname $(plugin) $(DLLWRAP_FLAGS) --def $(NAME).def $(OBJS) $(SHLIB_LINK)
	$(DLLTOOL) --dllname $(plugin) $(DLLTOOL_LIBFLAGS) --def $(NAME).def

endif # PORTNAME == win32

build_all: $(plugin)

build_install: build_all installdirs
	$(INSTALL_SHLIB) $(plugin) $(DESTDIR)$(pkglibdir)/$(plugin)
ifndef USE_GCJ
	$(INSTALL_DATA) ../$(pljava-jar) $(DESTDIR)$(pkglibdir)
endif

build_uninstall:
	rm -f $(DESTDIR)$(pkglibdir)/$(plugin)
ifndef USE_GCJ
	rm -f $(DESTDIR)$(pkglibdir)/$(pljava-jar)
endif

=== src/java/deploy/Makefile ===
#-------------------------------------------------------------------------
# Copyright (c) 2004, 2005, 2006 TADA AB - Taby Sweden
# Distributed under the terms shown in the file COPYRIGHT
# found in the root folder of this project or at
# http://eng.tada.se/osprojects/COPYRIGHT.html
#
# @author Thomas Hallgren
#-------------------------------------------------------------------------
NAME			:= deploy
JAVADOCTITLE	:= 'PL/Java deployer API Specification'

include $(MODULEROOT)/Makefile.global

all: $(JARFILE)

$(JARFILE): .timestamp
	$(JAR) cmf $(SRCDIR)/META-INF/manifest.txt $@ .

=== src/java/examples/Makefile ===
#-------------------------------------------------------------------------
# Copyright (c) 2004, 2005 TADA AB - Taby Sweden
# Distributed under the terms shown in the file COPYRIGHT
# found in the root folder of this project or at
# http://eng.tada.se/osprojects/COPYRIGHT.html
#
# @author Thomas Hallgren
#-------------------------------------------------------------------------
NAME 			:= examples
JAVADOCTITLE	:= 'PL/Java examples API Specification'
JAVAFLAGS		:= -classpath $(TARGETDIR)/classes/pljava

include $(MODULEROOT)/Makefile.global

all: $(JARFILE)

$(JARFILE): .timestamp \
			$(SRCDIR)/deployment/examples.manifest \
			$(SRCDIR)/deployment/examples.ddr \
			$(SRCDIR)/org/postgresql/pljava/example/example.properties
	$(JAR) cmf $(SRCDIR)/deployment/examples.manifest $@ . \
	-C $(SRCDIR) deployment/examples.ddr \
	-C $(SRCDIR) org/postgresql/pljava/example/example.properties

## postgresql-pljava 1.4.0

=== Makefile ===
--- 
+++ 
@@ -38,7 +38,7 @@
 export JNIDIR			:= $(TARGETDIR)/jni
 export CLASSDIR			:= $(TARGETDIR)/classes
 export PLJAVA_MAJOR_VER	:= 1
-export PLJAVA_MINOR_VER	:= 3
+export PLJAVA_MINOR_VER	:= 4
 export PLJAVA_PATCH_VER	:= 0
 export PLJAVA_VERSION	:= $(PLJAVA_MAJOR_VER).$(PLJAVA_MINOR_VER).$(PLJAVA_PATCH_VER)
 export TAR				:= /bin/tar

=== packaging/Makefile ===
--- 
+++ 
@@ -6,7 +6,7 @@
 #-------------------------------------------------------------------------
 include $(PGXS)
  
-SS_VERSION := $(subst ., ,$(subst devel,.devel,$(subst beta,.beta,$(VERSION))))
+SS_VERSION := $(subst ., ,$(subst devel,.devel,$(subst beta,.beta,$(subst RC,.RC,$(VERSION)))))
 PGSQL_MAJOR_VER = $(word 1,$(SS_VERSION))
 PGSQL_MINOR_VER = $(word 2,$(SS_VERSION))
 DISTRIB := distrib

=== src/C/pljava/Makefile ===
--- 
+++ 
@@ -26,7 +26,7 @@
 #
 include $(PGXS)
 
-SS_VERSION := $(subst ., ,$(subst devel,.99,$(subst beta,.99,$(VERSION))))
+SS_VERSION := $(subst ., ,$(subst devel,.99,$(subst beta,.99,$(subst RC,.99,$(VERSION)))))
 PGSQL_MAJOR_VER	= $(word 1,$(SS_VERSION))
 PGSQL_MINOR_VER	= $(word 2,$(SS_VERSION))
 PGSQL_PATCH_VER	= $(word 3,$(SS_VERSION))
@@ -55,10 +55,18 @@
 	ifeq ($(host_cpu), i686)
 		JRE_CPU := i386
 	else
+	ifeq ($(host_cpu), i586)
+		JRE_CPU := i386
+	else
+	ifeq ($(host_cpu), i486)
+		JRE_CPU := i386
+	else
 	ifeq ($(host_cpu), x86_64)
 		JRE_CPU := amd64
 	else
 		JRE_CPU := $(host_cpu)
+	endif
+	endif
 	endif
 	endif

## postgresql-pljava 1.4.2

=== Makefile ===
--- 
+++ 
@@ -28,7 +28,7 @@
 #
 export PROJDIR := $(shell $(SHELL) -c pwd)
 
-PG_CONFIG = pg_config
+export PG_CONFIG = pg_config
 export PGXS := $(shell $(PG_CONFIG) --pgxs)
 export PGSQLSRC := $(dir $(PGXS))..
 export top_builddir := $(PGSQLSRC)/..
@@ -39,7 +39,7 @@
 export CLASSDIR			:= $(TARGETDIR)/classes
 export PLJAVA_MAJOR_VER	:= 1
 export PLJAVA_MINOR_VER	:= 4
-export PLJAVA_PATCH_VER	:= 0
+export PLJAVA_PATCH_VER	:= 2
 export PLJAVA_VERSION	:= $(PLJAVA_MAJOR_VER).$(PLJAVA_MINOR_VER).$(PLJAVA_PATCH_VER)
 export TAR				:= /bin/tar
 
@@ -110,5 +110,3 @@
 maven_bundle: pljava_all
 	@-mkdir -p $(TARGETDIR)/distrib
 	@$(MAKE) -r -C $(TARGETDIR) -f $(PROJDIR)/packaging/Makefile $@
-
-

=== src/C/pljava/Makefile ===
--- 
+++ 
@@ -26,7 +26,7 @@
 #
 include $(PGXS)
 
-SS_VERSION := $(subst ., ,$(subst devel,.99,$(subst beta,.99,$(subst RC,.99,$(VERSION)))))
+SS_VERSION := $(subst ., ,$(subst devel,.99,$(subst beta,.99,$(subst alpha,.99,$(subst rc,.99,$(subst RC,.99,$(VERSION)))))))
 PGSQL_MAJOR_VER	= $(word 1,$(SS_VERSION))
 PGSQL_MINOR_VER	= $(word 2,$(SS_VERSION))
 PGSQL_PATCH_VER	= $(word 3,$(SS_VERSION))
@@ -68,6 +68,12 @@
 	endif
 	endif
 	endif
+	endif
+
+	ifeq ($(JRE_CPU), i386)
+		ifeq ($(findstring -m64, $(CFLAGS)), -m64)
+			JRE_CPU := amd64
+		endif
 	endif
 
 endif

=== debian/changelog ===
postgresql-pljava (1.4.2-4) unstable; urgency=low

  * Apparently, ia64 and hppa need an explicit include path to find jni_md.h.
    Closes: #559993.

 -- Christoph Berg <myon@debian.org>  Tue, 26 Jul 2011 10:47:21 +0200

postgresql-pljava (1.4.2-3) unstable; urgency=low

  * Use /usr/lib/jvm/java-1.5.0-gcj/include as include path; build-depend
    on gcj-jdk only. Closes: #633591. Thanks to Niels Thykier.
  * Use readlink to expand /usr/lib/jvm/java-1.5.0-gcj to the real location;
    the RPATH set needs it. (Still working around #488989.)
  * Drop build-dependency on fastjar.
  * Move examples to correct directory.

 -- Christoph Berg <myon@debian.org>  Tue, 12 Jul 2011 11:17:00 +0200

postgresql-pljava (1.4.2-2) unstable; urgency=low

  * Upload to unstable; drop 8.4 package.
  * Section: database.
  * Find libjvm in /usr/lib/jvm/java-1.5.0-gcj/lib instead of
    /java-1.5.0-gcj-4.4.
  * Declare our libjvm workaround good enough for now.
    Closes: #390661, #475069.
  * jni_md.h failures are not observed anymore. Closes: #559993.
  * Replace default-jdk-builddep by gcj-native-helper.
  * Dependencies are already fixed. Closes: #629618.
  * Install deploy.jar and examples.jar files. Closes: #388625.

 -- Christoph Berg <myon@debian.org>  Mon, 11 Jul 2011 23:15:56 +0200

postgresql-pljava (1.4.2-1) experimental; urgency=low

  * New upstream release.
  * Add myself as co-maintainer.
  * Convert to plain debhelper to add multi-version support using pg_buildext.
  * Update to build with PG 8.4 and 9.0.  Closes: #559591.
  * Use explicit -L/usr/lib/jvm/java-1.5.0-gcj-4.4/lib for now and link
    against libjvm (workaround for #390661, #475069, a proper fix is requested
    in #488989).
  * Despite being redundant, link against libgcj so we have a Depends on it.
  * Also add an RPATH for /usr/lib/jvm/java-1.5.0-gcj-4.4/lib (there's no good
    public location, see also #488989).
  * Update download location.  Closes: #600658.

 -- Christoph Berg <myon@debian.org>  Tue, 12 Apr 2011 16:50:58 +0200

postgresql-pljava (1.4.0-2) UNRELEASED; urgency=low

  * Added Vcs-* control fields
  * Updated standards version

 -- Peter Eisentraut <petere@debian.org>  Wed, 02 Jul 2008 17:22:16 +0200

postgresql-pljava (1.4.0-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Build-depend on default-jdk-builddep, don't build on alpha, arm, hppa.
    Closes: #477899.

 -- Matthias Klose <doko@debian.org>  Sun, 11 May 2008 11:38:42 +0200

postgresql-pljava (1.4.0-1) unstable; urgency=low

  * New upstream release (closes: #474084)
    - Obsoletes xact.patch
  * Built for PostgreSQL 8.3

 -- Peter Eisentraut <petere@debian.org>  Fri, 04 Apr 2008 22:27:34 +0200

postgresql-pljava (1.3.0-3) unstable; urgency=low

  * Fixed building where gcc version != gcj version (closes: #462501)

 -- Peter Eisentraut <petere@debian.org>  Sun, 03 Feb 2008 02:40:25 +0100

postgresql-pljava (1.3.0-2) unstable; urgency=low

  * Built for postgresql 8.2 (closes: #419305)
  * Use /usr/lib/postgresql/8.2/bin/pg_config rather than the first one in
    the path (closes: #441668)
  * Added fix to build with PostgreSQL 8.2 (xact.patch) (closes: #441668)
  * Rebuilt to fix libgcj dependency (closes: #436144)
  * Added Homepage control field
  * Updated standards version
  * Updated watch file

 -- Peter Eisentraut <petere@debian.org>  Mon, 10 Dec 2007 15:59:01 +0100

postgresql-pljava (1.3.0-1) unstable; urgency=low

  * New upstream release (closes: #375199)
  * Built for postgresql 8.1 (closes: #339641)
  * Rebuilt for new libgcj library (closes: #369986)
  * Updated copyright file
  * Updated standards version
  * Made use of cdbs simple patchsys

 -- Peter Eisentraut <petere@debian.org>  Mon, 26 Jun 2006 10:44:55 +0200

postgresql-pljava (1.1.0-5) unstable; urgency=low

  * Removed build dependency on libgcj6-dev, updated build dependency on
    gcj to a version where this is implicit (closes: #359726)
  * Changed to debhelper level 5

 -- Peter Eisentraut <petere@debian.org>  Tue, 18 Apr 2006 18:49:30 +0200

postgresql-pljava (1.1.0-4) unstable; urgency=low

  * Use /usr/lib/postgresql/8.0/bin/pg_config rather than the first one in
    the path (closes: #339947)
  * Depend on correct debhelper version for cdbs

 -- Peter Eisentraut <petere@debian.org>  Thu,  8 Dec 2005 22:20:02 +0100

postgresql-pljava (1.1.0-3) unstable; urgency=low

  * Also changed the Java compilation from -fpic to -fPIC so that the fix
    actually works

 -- Peter Eisentraut <petere@debian.org>  Mon, 12 Sep 2005 18:46:47 +0200

postgresql-pljava (1.1.0-2) unstable; urgency=low

  * Removed several workarounds from when GCC 4.0 was not the default yet
  * Updated standards version
  * Changed from -fpic to -fPIC to work around several build failures

 -- Peter Eisentraut <petere@debian.org>  Sun, 11 Sep 2005 20:44:35 +0200

postgresql-pljava (1.1.0-1) unstable; urgency=low

  * Initial release

 -- Peter Eisentraut <petere@debian.org>  Wed,  8 Jun 2005 16:43:28 +0200

=== debian/control ===
Source: postgresql-pljava
Section: database
Priority: optional
Maintainer: Peter Eisentraut <petere@debian.org>
Uploaders: Christoph Berg <myon@debian.org>
Build-Depends: debhelper (>= 5), gcj-jdk, postgresql-server-dev-all (>= 118)
Standards-Version: 3.9.2
Homepage: http://wiki.tada.se/index.php?title=Main_Page
Vcs-Svn: svn://svn.debian.org/pkg-postgresql/trunk/postgresql-pljava/
Vcs-Browser: http://svn.debian.org/wsvn/pkg-postgresql/trunk/postgresql-pljava/

Package: postgresql-9.0-pljava-gcj
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, postgresql-9.0
Provides: postgresql-9.0-pljava
Conflicts: postgresql-9.0-pljava
Description: Java procedural language for PostgreSQL 9.0
 PL/Java is a loadable procedural language for the PostgreSQL database
 system that enables the use of the Java language for creating functions
 and trigger procedures.  This variant is compiled using the GNU Compiler
 for Java (GCJ).

=== debian/rules ===
#!/usr/bin/make -f

SRCDIR=$(CURDIR)
include /usr/share/postgresql-common/pgxs_debian_control.mk

# Workaround for #488989:
# We need the expanded path at least for the RPATH because the symlink is only
# shipped in gcj-jre-headless which the bbuilt package does not depend on
export USR_LIB_JVM_GCJ := $(shell readlink -f /usr/lib/jvm/java-1.5.0-gcj)

build: build-stamp
build-stamp:
	dh_testdir
	test -d $(USR_LIB_JVM_GCJ)/include
	test -d $(USR_LIB_JVM_GCJ)/lib
	for version in $$(pg_buildext supported-versions .) ; do \
		echo "### Building for PostgreSQL $$version" && \
		$(MAKE) -C . USE_GCJ=1 PG_CONFIG=/usr/lib/postgresql/$$version/bin/pg_config CPPFLAGS+="-I$(USR_LIB_JVM_GCJ)/include -I$(USR_LIB_JVM_GCJ)/include/linux" && \
		mv build build-$$version || exit 1 ; \
	done
	touch build-stamp

clean: debian/control
	dh_testdir
	dh_testroot
	rm -rf build build-?.? build-stamp
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	for version in $$(pg_buildext supported-versions .) ; do \
		echo "### Installing for PostgreSQL $$version" && \
		mv build-$$version build && \
		PKG=postgresql-$$version-pljava-gcj && \
		DESTDIR=$(CURDIR)/debian/$$PKG && \
		$(MAKE) -C . install USE_GCJ=1 PG_CONFIG=/usr/lib/postgresql/$$version/bin/pg_config DESTDIR=$$DESTDIR && \
		install -d $$DESTDIR/usr/share/postgresql-$$version-pljava && \
		install -m 644 src/sql/*install.sql build/deploy.jar $$DESTDIR/usr/share/postgresql-$$version-pljava && \
		install -d $$DESTDIR/usr/share/doc/$$PKG/examples && \
		install -m 644 build/examples.jar $$DESTDIR/usr/share/doc/$$PKG/examples && \
		install -d $$DESTDIR/usr/share/lintian/overrides && \
		install -m644 debian/lintian-overrides $$DESTDIR/usr/share/lintian/overrides/$$PKG && \
		mv build build-$$version || exit 1 ; \
	done

binary-arch: install
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs -a --all debian/README.Debian docs/*.html
	dh_installexamples -a --all
	dh_install -a
	dh_link -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-arch binary-indep

.PHONY: build clean binary-indep binary-arch binary debian/control

## postgresql-pljava 1.4.3

=== Makefile ===
--- 
+++ 
@@ -28,8 +28,8 @@
 #
 export PROJDIR := $(shell $(SHELL) -c pwd)
 
-export PG_CONFIG = pg_config
-export PGXS := $(shell $(PG_CONFIG) --pgxs)
+export PG_CONFIG ?= pg_config
+export PGXS ?= $(shell $(PG_CONFIG) --pgxs)
 export PGSQLSRC := $(dir $(PGXS))..
 export top_builddir := $(PGSQLSRC)/..
 
@@ -39,12 +39,17 @@
 export CLASSDIR			:= $(TARGETDIR)/classes
 export PLJAVA_MAJOR_VER	:= 1
 export PLJAVA_MINOR_VER	:= 4
-export PLJAVA_PATCH_VER	:= 2
+export PLJAVA_PATCH_VER	:= 3
 export PLJAVA_VERSION	:= $(PLJAVA_MAJOR_VER).$(PLJAVA_MINOR_VER).$(PLJAVA_PATCH_VER)
 export TAR				:= /bin/tar
 
 OS := $(shell uname -s)
 MACHINE := $(shell uname -m)
+
+ifndef USE_GCJ
+JAVA_VERSION_MSG=PL/Java ${PLJAVA_VERSION} can only be compiled with JDK 1.4 or 1.5
+JAVA_VERSION := $(or $(filter 1.4% 1.5%, $(shell java -version 2>&1)),$(error ${JAVA_VERSION_MSG}))
+endif
 
 .PHONY: all clean docs javadoc source_tarball maven_bundle install uninstall depend release \
 	c_all c_install c_uninstall c_depend \

=== packaging/Makefile ===
--- 
+++ 
@@ -6,7 +6,7 @@
 #-------------------------------------------------------------------------
 include $(PGXS)
  
-SS_VERSION := $(subst ., ,$(subst devel,.devel,$(subst beta,.beta,$(subst RC,.RC,$(VERSION)))))
+SS_VERSION := $(subst ., ,$(subst devel,.devel,$(subst beta,.beta,$(subst rc,.rc,$(subst RC,.RC,$(VERSION))))))
 PGSQL_MAJOR_VER = $(word 1,$(SS_VERSION))
 PGSQL_MINOR_VER = $(word 2,$(SS_VERSION))
 DISTRIB := distrib

=== src/C/pljava/Makefile ===
--- 
+++ 
@@ -82,7 +82,7 @@
 
 ifdef USE_GCJ
 	PLJAVA_CPPFLAGS += -DGCJ
-	SHLIB_LINK = -lgcj
+	SHLIB_LINK = -lgcj $(PLJAVA_LDFLAGS)
 	ifdef DLL_BUILD
 		SHLIB_LINK += -lws2_32
 	endif
@@ -90,7 +90,7 @@
 else
 	pljava-jar = pljava.jar
 	ifeq ($(PORTNAME), darwin)
-		SHLIB_LINK += -L. -framework JavaVM
+		SHLIB_LINK += -L. -framework JavaVM $(PLJAVA_LDFLAGS)
 	else
 		ifdef JAVA_HOME
 			ifeq ($(PORTNAME), win32)
@@ -111,18 +111,74 @@
 			else
 				JRE_INCL := win32
 			endif
-			JVM_LIB  := $(JDK_HOME)/jre/bin/client
+			ifeq ($(host_cpu), x86_64)
+				JVM_LIB  := $(JDK_HOME)/jre/bin/server
+			else
+				JVM_LIB  := $(JDK_HOME)/jre/bin/client
+			endif
 		else
 			JRE_LIB := $(JDK_HOME)/jre/lib/$(JRE_CPU)
 			JVM_LIB := $(firstword $(shell /bin/ls -d \
 				$(JRE_LIB)/client \
 				$(JRE_LIB)/server \
 				$(JRE_LIB)/jrockit \
+				$(JDK_HOME)/jre/bin/j9vm \
 				2> /dev/null))
 		endif
 
 		PLJAVA_CPPFLAGS += -I"$(JDK_HOME)/include" -I"$(JDK_HOME)/include/$(JRE_INCL)"
-		SHLIB_LINK += -L. -L"$(JVM_LIB)" -ljvm
+		SHLIB_LINK += -L. -L"$(JVM_LIB)" -ljvm $(PLJAVA_LDFLAGS)
+
+		ifdef USE_LD_RPATH
+			ifeq (${USE_LD_RPATH},1)
+				SHLIB_LINK += -Wl,-rpath,${JVM_LIB}
+				ifneq ($(JVM_LIB), $(JVM_LIB:/j9vm=))
+					SHLIB_LINK += \
+						-Wl,-rpath,$(JVM_LIB:/j9vm=)
+				endif
+			else
+			ifeq (${USE_LD_RPATH},2)
+				SHLIB_LINK += -rpath ${JVM_LIB}
+				ifneq ($(JVM_LIB), $(JVM_LIB:/j9vm=))
+					SHLIB_LINK += \
+						-rpath $(JVM_LIB:/j9vm=)
+				endif
+			else
+			ifeq (${USE_LD_RPATH},3)
+				SHLIB_LINK += -R${JVM_LIB}
+				ifneq ($(JVM_LIB), $(JVM_LIB:/j9vm=))
+					SHLIB_LINK += \
+						-R$(JVM_LIB:/j9vm=)
+				endif
+			else
+			ifeq (${USE_LD_RPATH},4)
+				SHLIB_LINK += -R ${JVM_LIB}
+				ifneq ($(JVM_LIB), $(JVM_LIB:/j9vm=))
+					SHLIB_LINK += \
+						-R $(JVM_LIB:/j9vm=)
+				endif
+			else
+			ifeq (${USE_LD_RPATH},5)
+				SHLIB_LINK += -Wl,-R${JVM_LIB}
+				ifneq ($(JVM_LIB), $(JVM_LIB:/j9vm=))
+					SHLIB_LINK += \
+						-Wl,-R$(JVM_LIB:/j9vm=)
+				endif
+			else
+			ifeq (${USE_LD_RPATH},6)
+				SHLIB_LINK += -Wl,-R,${JVM_LIB}
+				ifneq ($(JVM_LIB), $(JVM_LIB:/j9vm=))
+					SHLIB_LINK += \
+						-Wl,-R,$(JVM_LIB:/j9vm=)
+				endif
+			endif
+			endif
+			endif
+			endif
+			endif
+			endif
+
+		endif
 	endif
 endif
 
@@ -184,11 +240,27 @@
 #
 $(plugin): $(OBJS)
 ifndef USE_GCJ
+ifneq ($(host_cpu), x86_64)
 	$(DLLTOOL) --input-def $(SRCDIR)/jvm.def --kill-at --dllname jvm.dll --output-lib libjvm.dll.a
 endif
-	$(DLLTOOL) --export-all $(DLLTOOL_DEFFLAGS) --output-def $(NAME).def $(OBJS)
-	$(DLLWRAP) $(LDFLAGS_SL) -o $(plugin) --dllname $(plugin) $(DLLWRAP_FLAGS) --def $(NAME).def $(OBJS) $(SHLIB_LINK)
-	$(DLLTOOL) --dllname $(plugin) $(DLLTOOL_LIBFLAGS) --def $(NAME).def
+endif
+ifeq ($(host_cpu), x86_64)
+	$(DLLTOOL) --export-all --output-def $(NAME).def $(OBJS)
+	$(DLLTOOL) --dllname $(plugin) $(DLLTOOL_LIBFLAGS) \
+		--def $(NAME).def
+	gendef - ${JVM_LIB}/jvm.dll > jvm.def
+	${DLLTOOL} --export-all-symbols --input-def jvm.def \
+		--output-lib libjvm.dll.a
+	${CC} -shared -o ${plugin} ${OBJS} ${BE_DLLLIBS} -L. -ljvm
+else
+	$(DLLTOOL) --export-all $(DLLTOOL_DEFFLAGS) \
+		--output-def $(NAME).def $(OBJS)
+	$(DLLWRAP) $(LDFLAGS_SL) -o $(plugin) --dllname $(plugin) \
+		$(DLLWRAP_FLAGS) --def $(NAME).def $(OBJS) \
+		$(SHLIB_LINK)
+	$(DLLTOOL) --dllname $(plugin) $(DLLTOOL_LIBFLAGS) \
+		--def $(NAME).def
+endif
 
 endif # PORTNAME == win32

=== src/java/pljava/Makefile ===
#-------------------------------------------------------------------------
# Copyright (c) 2004, 2005 TADA AB - Taby Sweden
# Distributed under the terms shown in the file COPYRIGHT
# found in the root folder of this project or at
# http://eng.tada.se/osprojects/COPYRIGHT.html
#
# @author Thomas Hallgren
#-------------------------------------------------------------------------
NAME			:= pljava
JAVADOCTITLE	:= 'PL/Java v$(PLJAVA_MAJOR_VER).$(PLJAVA_MINOR_VER) API Specification'

include $(MODULEROOT)/Makefile.global

SRCDIR_USC	:= $(subst .,^,$(SRCDIR))
mkclsrc		= $(subst ^,.,$(subst .,/,$(1:%=$(SRCDIR_USC)/%^java)))
JAVAH		:= javah

INTPKG		:= org.postgresql.pljava.internal
JDBCPKG		:= org.postgresql.pljava.jdbc

JNI_CLASSES := \
	$(INTPKG).Backend \
	$(INTPKG).SPI \
	$(INTPKG).AclId \
	$(INTPKG).ErrorData \
	$(INTPKG).Oid \
	$(INTPKG).ExecutionPlan \
	$(INTPKG).JavaWrapper \
	$(INTPKG).LargeObject \
	$(INTPKG).PgSavepoint \
	$(INTPKG).Portal \
	$(INTPKG).Relation \
	$(INTPKG).Session \
	$(INTPKG).SubXactListener \
	$(INTPKG).TriggerData \
	$(INTPKG).Tuple \
	$(INTPKG).TupleDesc \
	$(INTPKG).XactListener \
	$(JDBCPKG).Invocation \
	$(JDBCPKG).SingleRowReader \
	$(JDBCPKG).SQLInputFromChunk \
	$(JDBCPKG).SQLOutputToChunk \
	$(JDBCPKG).SQLInputFromTuple \
	$(JDBCPKG).SQLOutputToTuple

JNISRCS := $(call mkclsrc,$(JNI_CLASSES))

ifdef USE_GCJ
# We include both the pljava_jar.o and the pjlava.jar here although
# pljava doesn't need the latter. Most java compilers will need it
# in order to compile triggers and functions later.
#
JNIHDRS = $(patsubst %,$(JNIDIR)/%.h,$(subst .,_,$(JNI_CLASSES)))
mkcname = $(subst _,.,$(1:$(JNIDIR)/%.h=%))

all: $(OBJDIR)/$(NAME)_jar.o $(JARFILE) $(JNIDIR)/.timestamp

$(OBJDIR)/$(NAME)_jar.o: .timestamp
	@-mkdir -p $(@D)
	@echo $(GCJ) -c -fpic -fjni -o $@ '<java sources>'
	@$(GCJ) -c -fpic -fjni -o $@ $(SRCS)

# gcjh fails to clear its function name cache between files (see
# gcc bugzilla #17575) so we must do each file separately to
# avoid name ambiguities that causes names to be generated with
# parameter type info.
#
$(JNIHDRS): $(JNISRCS)
	@-mkdir -p $(@D)
	@gcjh -jni --classpath=. -d $(@D) $(call mkcname,$@)

# gcjh generated headers don't define final constants (see gcc
# bugzilla #16843) so we must copy our own version of java.sql.Types. 
#
$(JNIDIR)/.timestamp: $(JNIHDRS)
	@-mkdir -p $(@D)
	@cp $(PROJDIR)/fixes/gcj/java_sql_Types.h $(@D)
	@touch $@
else
all: $(JARFILE) $(JNIDIR)/.timestamp

$(JNIDIR)/.timestamp: $(JNISRCS)
	@-mkdir -p $(@D)
	@echo javah -classpath . -d $(@D) '<jni classes>'
	@javah -classpath . -d $(@D) $(JNI_CLASSES) java.sql.Types
	@touch $@

endif

$(JARFILE): .timestamp
	$(JAR) cf $@ .

=== debian/changelog ===
postgresql-pljava (1.4.3-3~1.gitc5d3def.pgdg14.04+1) trusty-pgdg; urgency=low

  * Rebuild for trusty-pgdg (jenkins-postgresql-pljava-source-
    distribution=trusty-1, git revision
    c5d3defd6400cf2a4d12feb5c53bbd7dc5eac175)

 -- apt.postgresql.org autobuilder <myon@debian.org>  Thu, 06 Feb 2014 17:59:00 +0100

postgresql-pljava (1.4.3-3) UNRELEASED; urgency=medium

  * Convert debian/rules to dh.
  * Add autopkgtest support.
  * Add 9.2 to supported versions (9.3 doesn't work yet).

 -- Christoph Berg <christoph.berg@credativ.de>  Thu, 06 Feb 2014 17:54:03 +0100

postgresql-pljava (1.4.3-2) unstable; urgency=low

  [ Christoph Berg ]
  * Remove disabled ldflags patch, implemented in debian/rules now.
  * Remove 8.1 version.
  * Fix format strings.  Closes: #664908.

  [ Peter Eisentraut ]
  * Removed myself as maintainer, promoted Christoph.

 -- Christoph Berg <myon@debian.org>  Tue, 27 Mar 2012 11:43:26 +0200

postgresql-pljava (1.4.3-1) unstable; urgency=low

  * New upstream version.
  * Build for PostgreSQL 9.1.  Closes: 639461.

 -- Christoph Berg <myon@debian.org>  Mon, 19 Sep 2011 11:02:32 +0200

=== debian/control ===
--- 
+++ 
@@ -4,10 +4,22 @@
 Maintainer: Peter Eisentraut <petere@debian.org>
 Uploaders: Christoph Berg <myon@debian.org>
 Build-Depends: debhelper (>= 5), gcj-jdk, postgresql-server-dev-all (>= 118)
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Homepage: http://wiki.tada.se/index.php?title=Main_Page
 Vcs-Svn: svn://svn.debian.org/pkg-postgresql/trunk/postgresql-pljava/
 Vcs-Browser: http://svn.debian.org/wsvn/pkg-postgresql/trunk/postgresql-pljava/
+XS-Testsuite: autopkgtest
+
+Package: postgresql-8.4-pljava-gcj
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}, postgresql-8.4
+Provides: postgresql-8.4-pljava
+Conflicts: postgresql-8.4-pljava
+Description: Java procedural language for PostgreSQL 8.4
+ PL/Java is a loadable procedural language for the PostgreSQL database
+ system that enables the use of the Java language for creating functions
+ and trigger procedures.  This variant is compiled using the GNU Compiler
+ for Java (GCJ).
 
 Package: postgresql-9.0-pljava-gcj
 Architecture: any
@@ -20,3 +32,25 @@
  and trigger procedures.  This variant is compiled using the GNU Compiler
  for Java (GCJ).
 
+Package: postgresql-9.1-pljava-gcj
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}, postgresql-9.1
+Provides: postgresql-9.1-pljava
+Conflicts: postgresql-9.1-pljava
+Description: Java procedural language for PostgreSQL 9.1
+ PL/Java is a loadable procedural language for the PostgreSQL database
+ system that enables the use of the Java language for creating functions
+ and trigger procedures.  This variant is compiled using the GNU Compiler
+ for Java (GCJ).
+
+Package: postgresql-9.2-pljava-gcj
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}, postgresql-9.2
+Provides: postgresql-9.2-pljava
+Conflicts: postgresql-9.2-pljava
+Description: Java procedural language for PostgreSQL 9.2
+ PL/Java is a loadable procedural language for the PostgreSQL database
+ system that enables the use of the Java language for creating functions
+ and trigger procedures.  This variant is compiled using the GNU Compiler
+ for Java (GCJ).
+

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/postgresql-common/pgxs_debian_control.mk

# Workaround for #488989:
# We need the expanded path at least for the RPATH because the symlink is only
# shipped in gcj-jre-headless which the bbuilt package does not depend on
export USR_LIB_JVM_GCJ := $(shell readlink -f /usr/lib/jvm/java-1.5.0-gcj)

override_dh_auto_clean:
	rm -rf build build-?.? results regression.*

override_dh_auto_build:
	test -d $(USR_LIB_JVM_GCJ)/include
	test -d $(USR_LIB_JVM_GCJ)/lib
	for version in $$(pg_buildext supported-versions .) ; do \
		echo "### Building for PostgreSQL $$version" && \
		$(MAKE) -C . USE_GCJ=1 PG_CONFIG=/usr/lib/postgresql/$$version/bin/pg_config CPPFLAGS+="-I$(USR_LIB_JVM_GCJ)/include -I$(USR_LIB_JVM_GCJ)/include/linux" PLJAVA_LDFLAGS="-L$(USR_LIB_JVM_GCJ)/lib -Wl,-R$(USR_LIB_JVM_GCJ)/lib -ljvm" && \
		mv build build-$$version || exit 1 ; \
	done

override_dh_auto_test:

override_dh_auto_install:
	for version in $$(pg_buildext supported-versions .) ; do \
		echo "### Installing for PostgreSQL $$version" && \
		mv build-$$version build && \
		PKG=postgresql-$$version-pljava-gcj && \
		DESTDIR=$(CURDIR)/debian/$$PKG && \
		$(MAKE) -C . install USE_GCJ=1 PG_CONFIG=/usr/lib/postgresql/$$version/bin/pg_config DESTDIR=$$DESTDIR && \
		install -d $$DESTDIR/usr/share/postgresql-$$version-pljava && \
		install -m 644 src/sql/*install.sql build/deploy.jar $$DESTDIR/usr/share/postgresql-$$version-pljava && \
		install -d $$DESTDIR/usr/share/doc/$$PKG/examples && \
		install -m 644 build/examples.jar $$DESTDIR/usr/share/doc/$$PKG/examples && \
		install -d $$DESTDIR/usr/share/lintian/overrides && \
		install -m644 debian/lintian-overrides $$DESTDIR/usr/share/lintian/overrides/$$PKG && \
		mv build build-$$version || exit 1 ; \
	done

override_dh_installdocs:
	dh_installdocs -a --all debian/README.Debian docs/*.html

%:
	dh $@

## postgresql-pljava 1.5.1

=== debian/changelog ===
postgresql-pljava (1.5.1-1.pgdg14.04+1) trusty-pgdg; urgency=medium

  * Rebuild for trusty-pgdg.
  * No source changes.

 -- apt.postgresql.org autobuilder <pgsql-pkg-debian@postgresql.org>  Wed, 17 Oct 2018 12:46:11 +0200

postgresql-pljava (1.5.1-1) unstable; urgency=medium

  * New upstream version.
  * Use the system's default Java version for libjvm.so at runtime instead of
    the one used for compilation.
  * Put default-jre-headless in runtime dependency, and add
    java-runtime-headless alternative.
  * Remove GCJ from package description, mention libjvm.so used by default
    instead.

 -- Christoph Berg <christoph.berg@credativ.de>  Wed, 17 Oct 2018 12:46:11 +0200

postgresql-pljava (1.5.1~beta3-1) unstable; urgency=medium

  * New upstream beta version, now based on maven.
  * Rename binary package to postgresql-NN-pljava without any suffix;
    building using openjdk-8-jdk-headless.
  * Convert debian/rules to dh.
  * Add autopkgtest support.
  * Add nar aol properties file for compiling/linking on ppc46el.
    Suggested by Chapman Flack, thanks!
  * Cherry-pick upstream patch to fix breakage of default libjvm path on i386.

 -- Christoph Berg <christoph.berg@credativ.de>  Mon, 08 Oct 2018 12:39:19 +0200

postgresql-pljava (1.4.3-3) unstable; urgency=low

  * Build for PostgreSQL 9.3 (closes: #731518)

 -- Peter Eisentraut <petere@debian.org>  Thu, 13 Mar 2014 00:16:40 -0400

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/postgresql-common/pgxs_debian_control.mk
include /usr/share/dpkg/architecture.mk

# use Java 8 (or 6/7) for compilation
export JAVA_HOME = $(wildcard /usr/lib/jvm/java-[678]-openjdk-*)
# use the default Java for libjvm at runtime
DPKG_S = $(shell dpkg -S '/usr/lib/jvm/*/libjvm.so' | sort -V | tail -1)
JRE_DEB = $(shell echo $(firstword $(DPKG_S)) | sed -e 's/:.*//')
LIBJVM_SO = $(lastword $(DPKG_S))

ifeq ($(DEB_HOST_ARCH),ppc64el)
AOLPROPERTIES = -Dnar.aolProperties=pljava-so/aol.properties
endif

override_dh_auto_clean:
	# disable fakeroot here, we need the real ~/.m2
	LD_PRELOAD= mvn --batch-mode clean
	rm -rf build-*

override_dh_auto_build:
	set -ex; \
	for version in $$(pg_buildext supported-versions .) ; do \
		PG_CONFIG=/usr/lib/postgresql/$$version/bin/pg_config; \
		echo "### Compiling for PostgreSQL $$version"; \
		mvn --batch-mode -Pwnosign -Dso.debug=true $(AOLPROPERTIES) \
		    -Dpgsql.pgconfig=$$PG_CONFIG \
		    -Dpljava.libjvmdefault=$(LIBJVM_SO) \
		    clean install; \
		mkdir -p build-$$version; \
		cp pljava-packaging/target/pljava-pg$$version*.jar build-$$version; \
	done

override_dh_auto_test:

override_dh_auto_install:
	set -ex; \
	for version in $$(pg_buildext supported-versions .) ; do \
		PG_CONFIG=/usr/lib/postgresql/$$version/bin/pg_config; \
		echo "### Installing for PostgreSQL $$version"; \
		java -Dpgsql.pgconfig=$$PG_CONFIG \
		     -Dpgconfig.pkglibdir=debian/postgresql-$$version-pljava/usr/lib/postgresql/$$version/lib \
		     -Dpgconfig.sharedir=debian/postgresql-$$version-pljava/usr/share/postgresql/$$version \
		     -jar build-$$version/pljava-pg$$version*.jar; \
	done

override_dh_installdocs:
	dh_installdocs --all docs/*.html

override_dh_gencontrol:
	# add dependency on $(JRE_DEB) for libjvm.so
	dh_gencontrol -- -V"jre:Depends=$(JRE_DEB)"

%:
	dh $@

=== debian/tests/control ===
Depends: @, postgresql-server-dev-all
Tests: installjar
Restrictions: allow-stderr
